package it.unibo.tw0708.utils;

import static org.junit.Assert.*;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

public class ValentineTester {

	/**
	 * Utilities to be run before all tests
	 * @throws Exception
	 */
	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
	}

	/**
	 * Utilities to be run before all tests
	 * @throws Exception
	 */
	@AfterClass
	public static void tearDownAfterClass() throws Exception {
	}

	/**
	 * Utilities to be run before each test
	 * @throws Exception
	 */
	@Before
	public void setUp() throws Exception {
	}

	/**
	 * Utilities to be run after each test
	 * @throws Exception
	 */
	@After
	public void tearDown() throws Exception {
	}

	// -------------------------------------------------------------------------------------------
	
	/**
	 * Test method for 'it.unibo.tw0708.utils.Valentine.heartMatch(String, String)'
	 */
	@Test
	public void heartMatch() {
		try {
			int score = Valentine.heartMatch("Andrea","Andrea");
			assertEquals("Two persons with the same name have no chances...",0,score);
		}
		catch (Exception e) {
			fail("Something went wrong while heart matching...");
		}
	}

	/**
	 * Test method for 'it.unibo.tw0708.utils.Valentine.fortuneTell(String, String)'
	 */
	@Test
	public void fortuneTell() {
		String story = Valentine.fortuneTell("Andrea","Andrea");
		assertTrue("Too similar",story.startsWith("Two too"));
	}

	/**
	 * Test method for 'it.unibo.tw0708.utils.Valentine.fortuneTell(String, String)'
	 */
	@Test
	public void fortuneTell_AtLeastTwo() {
		String story = Valentine.fortuneTell("Andrea","");
		assertTrue("Too similar",story.contains("needed"));
		story = Valentine.fortuneTell("Andrea",null);
		assertTrue("Too similar",story.contains("needed"));
		story = Valentine.fortuneTell("","Andrea");
		assertTrue("Too similar",story.contains("needed"));
		story = Valentine.fortuneTell(null,"Andrea");
		assertTrue("Too similar",story.contains("needed"));
	}

}
